<template>
  <transition name="modal">
    <div class="modal-mask">
      <div class="modal-wrapper">
        <div
          class="modal-container"
          :class="{ 'full-width': fullWidth, 'no-default': noDefault }"
        >
          <button
            v-if="closingCross"
            class="modal-default-button"
            @click="$emit('close')"
          >
            <img
              class="button_close"
              alt="close"
              :src="require('~/assets/images/close.svg')"
            />
          </button>
          <div class="modal-header">
            <slot name="header"></slot>
          </div>

          <div class="modal-body">
            <slot name="body"></slot>
          </div>

          <div class="modal-footer">
            <slot name="footer">
              <AppButton v-if="!noDefault" @click.native="$emit('close')">
                OK
              </AppButton>
            </slot>
          </div>
          <slot name="footer-link"></slot>
        </div>
      </div>
    </div>
  </transition>
</template>

<script>
import AppButton from '~/components/ui/AppButton'

export default {
  components: {
    AppButton
  },
  props: {
    noDefault: {
      type: Boolean,
      required: false,
      default: false
    },
    fullWidth: {
      type: Boolean,
      required: false,
      default: false
    },
    closingCross: {
      type: Boolean,
      required: false,
      default: false
    }
  }
}
</script>

<style lang="scss" scoped>
.modal-mask {
  position: fixed;
  z-index: 9998;
  top: 0;
  left: 0;
  width: 100%;
  height: 100%;
  background-color: rgba(39, 38, 38, 0.8);
}

.modal-wrapper {
  min-width: 500px;
  max-width: 100%;
  position: absolute;
  top: 50%;
  left: 50%;
  transform: translate(-50%, -50%);
  transition: all 0.3s ease;

  @media (max-width: 768px) {
    padding: 0 1rem;
    min-width: inherit;
    width: inherit;
  }
}

.modal-container {
  background-color: #fff;
  padding: 3rem 5rem;
  text-align: center;
  position: relative;
  max-height: 100vh;
  z-index: 99999;
  overflow: auto;

  .closing-cross {
    position: absolute;
    right: 1rem;
    top: 1rem;
    cursor: pointer;
  }

  .modal-default-button {
    position: absolute;
    right: 20px;
    top: 55px;
    background-color: #fff;
    z-index: 1000000;
  }

  .button_close {
    width: 15px;
    height: 15px;
  }

  .modal-body {
    margin: 1rem 0;
  }

  .modal-footer {
    margin-top: 3rem;
    margin-bottom: 1rem;
  }

  @media (max-width: 768px) {
    padding: 3rem;

    &.full-width {
      padding: 1rem;
    }
  }
}

.no-default {
  .modal-footer {
    margin: 0;
  }
}

.modal-enter {
  opacity: 0;
}

.modal-leave-active {
  opacity: 0;
}

.modal-enter .modal-container,
.modal-leave-active .modal-container {
  -webkit-transform: scale(1.1);
  transform: scale(1.1);
}
</style>
